import { DataSource } from '@angular/cdk/collections';
import { Subject } from 'rxjs/Subject';
import { Observable } from 'rxjs/Observable';
import { TableElement } from './table-element';
import { ValidatorService } from './validator.service';
export declare class TableDataSource<T> extends DataSource<TableElement<T>> {
    private validatorService;
    private rowsSubject;
    datasourceSubject: Subject<T[]>;
    private dataConstructor;
    private dataKeys;
    constructor(data: T[], dataType?: new () => T, validatorService?: ValidatorService);
    confirmEdit(row: TableElement<T>): void;
    confirmCreate(row: TableElement<T>): void;
    createNew(): void;
    delete(id: number): void;
    getDataFromRows(rows: TableElement<T>[]): T[];
    updateDatasource(rows: TableElement<T>[]): void;
    getRowsFromData(data: T[]): TableElement<T>[];
    createNewObject(): any;
    /** Connect function called by the table to retrieve one stream containing the data to render. */
    connect(): Observable<TableElement<T>[]>;
    disconnect(): void;
}
